/**************************************************************************/
/*                                                                        */
/*                        CD Emulation source file                        */
/*                                                                        */
/*    This file is intended to be included in the case which handle the   */
/* execution of the opcodes, when occur a 0xFC opcode, we must either     */
/* restoring the jump thanks to the data situated just after the invalid  */
/* opcode or make the function by ourself, returning with a 'RTS' with a  */
/* value in A, 0 means success and other value for an error               */
/*                                                                        */
/*     Code source by Zeograd, tell me if you make any use of this        */
/*              Help really wanted on all of this                         */
/*                                                                        */
/**************************************************************************/

/* CD related functions */

#define CD_BOOT   0x00
#define CD_RESET  0x01
#define CD_BASE   0x02
#define CD_READ   0x03
#define CD_SEEK   0x04
#define CD_EXEC   0x05
#define CD_PLAY   0x06
#define CD_SEARCH 0x07
#define CD_PAUSE  0x08
#define CD_STAT   0x09
#define CD_SUBA   0x0A
#define CD_DINFO  0x0B
#define CD_CONTENTS 0x0C
#define CD_SUBRQ  0x0D
#define CD_PCMRD  0x0E
#define CD_FADE   0x0F

/* ADPCM related functions */

#define AD_RESET  0x10
#define AD_TRANS  0x11
#define AD_READ   0x12
#define AD_WRITE  0x13
#define AD_PLAY   0x14
#define AD_CPLAY  0x15
#define AD_STOP   0x16
#define AD_STAT   0x17

/* BACKUP MEM related functions */

#define BM_FORMAT 0x18
#define BM_FREE   0x19
#define BM_READ   0x1A
#define BM_WRITE  0x1B
#define BM_DELETE 0x1C
#define BM_FILES  0x1D

/* Miscelanous functions */

#define EX_GETVER 0x1E
#define EX_SETVEC 0x1F
#define EX_GETFNT 0x20
#define EX_JOYSNS 0x21
#define EX_JOYREP 0x22
#define EX_SCRSIZ 0x23
#define EX_DOTMOD 0x24
#define EX_SCRMOD 0x25
#define EX_IMODE  0x26
#define EX_VMOD   0x27
#define EX_HMOD   0x28
#define EX_VSYNC  0x29
#define EX_RCRON  0x2A
#define EX_RCOFF  0x2B
#define EX_IRQON  0x2C
#define EX_IRQOFF 0x2D
#define EX_BGON   0x2E
#define EX_BGOFF  0x2F
#define EX_SPRON  0x30
#define EX_SPROFF 0x31
#define EX_DSPON  0x32
#define EX_DPSOFF 0x33
#define EX_DMAMOD 0x34
#define EX_SPRDMA 0x35
#define EX_SATCLR 0x36
#define EX_SPRPUT 0x37
#define EX_SETRCR 0x38
#define EX_SETRED 0x39
#define EX_SETWRT 0x3A
#define EX_SETDMA 0x3B
#define EX_BINBCD 0x3C
#define EX_BCDBNI 0x3D
#define EX_RND    0x3E

/* Math related functions */

#define MA_MUL8U  0x3F
#define MA_MUL8S  0x40
#define MA_MU16U  0x41
#define MA_DIV16S 0x42
#define MA_DIV16U 0x43
#define MA_SQRT   0x44
#define MA_SIN    0x45
#define MA_COS    0x46
#define MA_ATNI   0x47

/* PSG BIOS functions */

#define PSG_BIOS  0x48
#define GRP_BIOS  0x49
#define KEY_BIOS  0x4A
#define PSG_DRIVE 0x4B
#define EX_COLORC 0x4C

#define RTS M_POP(_PC.B.l);M_POP(_PC.B.h);_PC_++
// all user defined function must end by a RTS to go back to
// the PC of the calling function

case 0xFC:
     // Invalid opcode meaning a CD BIOS function have been called
     { // currently, just replace the original opcodes
      UInt16 number=Op6502(_PC_--);

#ifndef FINAL_RELEASE
      fprintf(stderr,"CD BIOS CALL AT %04X\nfunction #%02x\n",_PC_,number);
#endif

      switch (number)
        {
        case CD_RESET:
             // do nothing
             // don't return any value
             RTS;
             break;
        case AD_RESET:
             // do nothing
             // don't return any value
             RTS;
             break;
        case EX_VSYNC:
             // for speedy emu, never wait
             // don't return any value
             RTS;
             break;
        default:
          _Wr6502(_PC_,CDBIOS_replace[number][0]);
          _Wr6502(_PC_+1,CDBIOS_replace[number][1]);
        }

      //exit(-1);
      }
     break;

