#include "config.h"

const char* joy_str[]={"UP","DOWN","LEFT","RIGHT","I","II","SELECT","START","AUTOI","AUTOII"};

char set_arg(char nb_arg,char* val)
  {
     if (!val)
       {
		  #ifndef FINAL_RELEASE
         fprintf(stderr,"No value for %c arg\n",nb_arg);
        #endif
         return 1;
       };
     switch (nb_arg)
       {
              case 'v' :
                   vmode=atoi(val);
                   return 0;
              case 's' :
                   smode=atoi(val);
                   return 0;
              case 'd' :
                   debug_on_beginning=atoi(val);
                   return 0;
              case 'j' :
                   nb_joy=atoi(val);
                   nb_joy=min(nb_joy,5);
                   nb_joy=max(1,nb_joy);
                   //io.joy_counter=nb_joy;
                     // nb_joy = [| 1 .. 5 |]
                   return 0;
              case 'u' :
						 US_encoded_card=atoi(val);
                   break;
              case 'c' :
                   CD_emulation=atoi(val);
                   break;
              default:
              #ifndef FINAL_RELEASE
                   fprintf(stderr,"Unrecognized option : %c\n",nb_arg);
              #endif
                   return 1;
       }
   };

void parse_commandline(int argc,char** argv)
 {
  char next_arg,i,arg_error=0;

      next_arg=0;
      for(i=1;i<argc;i++)
        if (!next_arg)
                {
                   if (argv[i][0]=='-')
                     {
                      if (strlen(argv[i])==2)
                        next_arg=argv[i][1];
                      else
                        arg_error|=set_arg(argv[i][1],(char*)&argv[i][2]);
                     }
                   else
                     {
                      if (!cart_name[0])
                        {
                         strupr(argv[i]);
                         strcpy(cart_name,argv[i]);
                         {int x;
                          for (x=0;x<strlen(cart_name);x++ )
                             if (cart_name[x]=='\\')
                               cart_name[x]='/';
                          }
                         }
                      else
                        if (!bmdefault)
                          {
                           strupr(argv[i]);
                           bmdefault=argv[i];
                           }
                        else
                          {
                            //fprintf(stderr,"Unrecognised option : %s\n",argv[i]);
                            arg_error=1;
                          };
                        }
                }
              else
                {
                  arg_error|=set_arg(next_arg,argv[i]);
                  next_arg=0;
                }

      if (next_arg)
        {
          //fprintf(stderr,"No value for arg %c\n",next_arg);
          next_arg=0;
          arg_error=1;
        };
  return ;
  }

void parse_INIfile()
 {
	unsigned	char dum;
	char tmp_path[80];
   char tmp_str[10],tmp_str2[10],section_name[10],x,y,z;
	unsigned	short temp_val;

   strcpy(tmp_path,short_exe_name);
   strcat(tmp_path,"HU-GO!.INI");

   set_config_file(tmp_path);

// Default value for first input
for (dum=0;dum<5;dum++ )
   {
    joy_mapping[dum][J_DOWN]=KEY_DOWN;
    joy_mapping[dum][J_UP]=KEY_UP;
    joy_mapping[dum][J_LEFT]=KEY_LEFT;
    joy_mapping[dum][J_RIGHT]=KEY_RIGHT;
    joy_mapping[dum][J_SELECT]=KEY_TAB;
    joy_mapping[dum][J_START]=KEY_ENTER;
    joy_mapping[dum][J_I]=KEY_ALT;
    joy_mapping[dum][J_II]=KEY_SPACE;
    joy_mapping[dum][J_AUTOI]=KEY_C;
    joy_mapping[dum][J_AUTOII]=KEY_X;
   }

   memset(tmp_str,0,10);

   for (x=1;x<=5;x++)
      {  // for each joystick
        for (y=0;y<10;y++)
           {
            strcpy(tmp_str,joy_str[y]);
            tmp_str[strlen(tmp_str)+1]=0;
            tmp_str[strlen(tmp_str)]=x+0x30;

				if ((temp_val=get_config_hex(NULL,tmp_str,0)))
				  joy_mapping[x-1][y]=temp_val;

           }
      }


    strcpy(section_name,"CONFIG1");
    for (z=1;z<16;z++)
     {
      if (z<10)
        section_name[6]='0'+z;
      else
        section_name[6]=z-10+'a';

      for (x=1;x<=5;x++)
      {  // for each joystick

        strcpy(tmp_str2,"input1");
        tmp_str2[5]='0'+x;

        config[z].input_type[x-1]=NONE;

        strcpy(tmp_str,get_config_string(section_name,tmp_str2,""));

        if (!stricmp(tmp_str,"key1"))
          config[z].input_type[x-1]=KEYBOARD1;
        else if (!stricmp(tmp_str,"key2"))
          config[z].input_type[x-1]=KEYBOARD2;
        else if (!stricmp(tmp_str,"key3"))
          config[z].input_type[x-1]=KEYBOARD3;
        else if (!stricmp(tmp_str,"key4"))
          config[z].input_type[x-1]=KEYBOARD4;
        else if (!stricmp(tmp_str,"key5"))
          config[z].input_type[x-1]=KEYBOARD5;
        else if (!stricmp(tmp_str,"joy1"))
          config[z].input_type[x-1]=JOYPAD1;
        else if (!stricmp(tmp_str,"joy2"))
          config[z].input_type[x-1]=JOYPAD2;
        else if (!stricmp(tmp_str,"joy3"))
          config[z].input_type[x-1]=JOYPAD3;
        else if (!stricmp(tmp_str,"joy4"))
          config[z].input_type[x-1]=JOYPAD4;
        else if (!stricmp(tmp_str,"mouse1"))
          config[z].input_type[x-1]=MOUSE1;
        else if (!stricmp(tmp_str,"mouse2"))
          config[z].input_type[x-1]=MOUSE2;
        else if (!stricmp(tmp_str,"synaplink"))
          config[z].input_type[x-1]=SYNAPLINK;

        for (y=0;y<10;y++)
           {
            strcpy(tmp_str,joy_str[y]);
            tmp_str[strlen(tmp_str)+1]=0;
            tmp_str[strlen(tmp_str)]=x+0x30;

				if ((temp_val=get_config_hex(section_name,tmp_str,0)))
				  config[z].joy_mapping[x-1][y]=temp_val;

           }
      }
     }

   // If there, we haven't found any input related stuff

	strcpy(initial_path,get_config_string(NULL,"rom_dir","."));
	if ((initial_path[0]) && (initial_path[strlen(initial_path)-1]!='/')
		 && (initial_path[strlen(initial_path)-1]!='\\'))
   strcat(initial_path,"/");
	// rom_dir setting

   current_config=get_config_int(NULL,"config",0);
   // choose input config

	language=min(get_config_int(NULL,"language",0),NB_LANG-1);
	// language setting

   if (exact_putspritem=get_config_int(NULL,"exact_draw",0))
	  {
	    //PutSpriteMaskedFunction=PutSpriteM;
		 //PutSpriteMakeMaskedFunction=PutSpriteMakeMask;
		 RefreshSprite=RefreshSpriteExact;
     }
   else
	  {
		 // Here, we can put as many things as we want that can increase speed

		 RefreshSprite=RefreshSpriteSpeedy;
	    //PutSpriteMaskedFunction=PutSprite;
		 //PutSpriteMakeMaskedFunction=PutSprite;
     }
   // exact_draw setting

	nb_joy=get_config_int(NULL,"nb_joy",1);
   nb_joy=min(nb_joy,5);
   nb_joy=max(1,nb_joy);
	// number of joy setting

	vmode=get_config_int(NULL,"vmode",0);
	// video mode setting

	smode=get_config_int(NULL,"smode",-1);
	// sound mode setting

   static_refresh=get_config_int(NULL,"static_refresh",0);
   // file selector refreshment

	for (dum=0;dum<MAX_USER_BP;dum++)
		 memset(&Bp_list[dum],0,sizeof(Breakpoint));
   // clear all breakpoints

	for (dum=0;dum<5;dum++)
      {
		  auto_fire_A[dum]=0;
		  auto_fire_B[dum]=0;
      }
   // clear auto_fire

   for (x=0;x<5;x++)
      {
       if (config[current_config].input_type[x]==NONE)
         config[current_config].pad[x]=noinput;
       else if (config[current_config].input_type[x]==KEYBOARD1)
         config[current_config].pad[x]=keyboard1;
       else if (config[current_config].input_type[x]==KEYBOARD2)
         config[current_config].pad[x]=keyboard2;
       else if (config[current_config].input_type[x]==KEYBOARD3)
         config[current_config].pad[x]=keyboard3;
       else if (config[current_config].input_type[x]==KEYBOARD4)
         config[current_config].pad[x]=keyboard4;
       else if (config[current_config].input_type[x]==KEYBOARD5)
         config[current_config].pad[x]=keyboard5;
       else if (config[current_config].input_type[x]==JOYPAD1)
         config[current_config].pad[x]=joypad1;
       else if (config[current_config].input_type[x]==JOYPAD2)
         config[current_config].pad[x]=joypad2;
       else if (config[current_config].input_type[x]==JOYPAD3)
         config[current_config].pad[x]=joypad3;
       else if (config[current_config].input_type[x]==JOYPAD4)
         config[current_config].pad[x]=joypad4;
       else if (config[current_config].input_type[x]==MOUSE1)
         config[current_config].pad[x]=mouse1;
       else if (config[current_config].input_type[x]==MOUSE2)
         config[current_config].pad[x]=mouse2;
       else if (config[current_config].input_type[x]==SYNAPLINK)
         config[current_config].pad[x]=synaplink;
      }

	return ;
   }
