#ifndef _DJGPP_INCLUDE_DEBUG_H
#define _DJGPP_INCLUDE_DEBUG_H

#include "pce.h"
#include "dis.h"
#include "optable.h"

#define  MAX_BP        16
// Max number of breakpoints

#define  MAX_USER_BP   14
// Max number of breakpoints user definabled

#define  RESTORE_BP    14
// Place in the list of a pseudo-break point for internal usage

#define  GIVE_HAND_BP  15
// Place in the list of the breakpoint used in stepping...

// Some defines for the flag value
#define	NOT_USED   0
#define  ENABLED    1
#define  DISABLED	  2

typedef struct {
        unsigned short position;
		  char flag;
		  unsigned char original_op;
        } Breakpoint;

extern Breakpoint Bp_list[MAX_BP];
// The list of all breakpoints

extern char save_background;
// Do we have to preserve the background

void disass_menu();
// Kind of front end for the true disassemble function

int toggle_user_breakpoint(UInt16);
// Toggle the breakpoint at the specified address

void display_debug_help();
// Display a help screen

UInt32 cvtnum(char * string);
// Convert a hexa string into a number

void set_bp_following(UInt16 where, UChar nb);
// set a bp at the location that follows a given address
#endif
